/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     EOL = 258,
     AUTH = 259,
     ACCT = 260,
     SEND = 261,
     EXPECT = 262,
     T_BEGIN = 263,
     T_END = 264,
     IF = 265,
     ELSE = 266,
     WHILE = 267,
     DO = 268,
     BREAK = 269,
     CONTINUE = 270,
     INPUT = 271,
     SHIFT = 272,
     GETOPT = 273,
     CASE = 274,
     IN = 275,
     T_RETURN = 276,
     SET = 277,
     PRINT = 278,
     EXIT = 279,
     T_BOGUS = 280,
     ARGCOUNT = 281,
     IDENT = 282,
     PARM = 283,
     NAME = 284,
     NUMBER = 285,
     QUOTE = 286,
     BSTRING = 287,
     IPADDRESS = 288,
     PRITEM = 289,
     OR = 290,
     AND = 291,
     NE = 292,
     EQ = 293,
     GE = 294,
     GT = 295,
     LE = 296,
     LT = 297,
     NOT = 298,
     UMINUS = 299
   };
#endif
#define EOL 258
#define AUTH 259
#define ACCT 260
#define SEND 261
#define EXPECT 262
#define T_BEGIN 263
#define T_END 264
#define IF 265
#define ELSE 266
#define WHILE 267
#define DO 268
#define BREAK 269
#define CONTINUE 270
#define INPUT 271
#define SHIFT 272
#define GETOPT 273
#define CASE 274
#define IN 275
#define T_RETURN 276
#define SET 277
#define PRINT 278
#define EXIT 279
#define T_BOGUS 280
#define ARGCOUNT 281
#define IDENT 282
#define PARM 283
#define NAME 284
#define NUMBER 285
#define QUOTE 286
#define BSTRING 287
#define IPADDRESS 288
#define PRITEM 289
#define OR 290
#define AND 291
#define NE 292
#define EQ 293
#define GE 294
#define GT 295
#define LE 296
#define LT 297
#define NOT 298
#define UMINUS 299




/* Copy the first part of user declarations.  */
#line 1 "gram.y"

/* This file is part of GNU Radius.
   Copyright (C) 2000,2001,2002,2003,2004 Free Software Foundation, Inc.

   Written by Sergey Poznyakoff
  
   GNU Radius is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   GNU Radius is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with GNU Radius; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */

#if defined(HAVE_CONFIG_H)        
# include <config.h>
#endif
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/file.h>
#include <sys/stat.h>
#include <netinet/in.h>
         
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <fcntl.h>
#include <ctype.h>
#include <unistd.h>
#include <signal.h>
#include <errno.h>
#include <sys/wait.h>

#include <common.h>
#include <radtest.h>

#define YYERROR_VERBOSE 1
	
extern int yylex();

/* Local variables */ 
static int current_nesting_level; /* Nesting level of WHILE/DO statements */
static int error_count;           /* In interactive mode: number of errors
				     in the statement being compiled. Gets
				     reset to 0 after each statement.
				     In batch mode: total number of errors
				     encountered so far */
 
static struct {                   /* Definition of the function currently
				     being compiled */
	char *function;           /* Function name */
	grad_locus_t locus;       /* Location of the beginning of
				     the definition */
} defn;

/* Context stack support. This is used for improving diagnostic
   messages and after-error synchronization */
   
struct context_stack {
	struct context_stack *next;
	enum context ctx;
};

static struct context_stack *context_stack;
 
static enum context 
push_ctx(enum context ctx)
{
	struct context_stack *p = grad_emalloc(sizeof(*p));
	p->ctx = ctx;
	p->next = context_stack;
	context_stack = p;
	return ctx;
}

enum context
pop_ctx()
{
	enum context ctx;
	struct context_stack *p = context_stack;
	
	if (!context_stack)
		return ctx_none;
	ctx = p->ctx;
	context_stack = p->next;
	grad_free(p);
	return ctx;
}

enum context
peek_ctx()
{
	return context_stack ? context_stack->ctx : ctx_none;
}

/* Forward declarations */
static void run_statement(radtest_node_t *node);
static void errsync();
int yyerror(char *s);
 


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 148 "gram.y"
typedef union YYSTYPE {
	int i;
	long number;
	char *string;
	radtest_node_t *node;
	radtest_node_deref_var_t deref;
	radtest_node_deref_parm_t parm;
	grad_uint32_t ipaddr;
	enum grad_operator op;
	radtest_pair_t *pair;
	grad_list_t *list;
	radtest_variable_t *var;
	grad_symtab_t *symtab;
	struct {
		int argc;
		char **argv;
	} set;
	radtest_case_branch_t *case_branch;
	radtest_function_t *fun;
	radtest_bstring_t bstring;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 294 "gram.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 306 "gram.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   513

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  55
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  43
/* YYNRULES -- Number of rules. */
#define YYNRULES  124
/* YYNRULES -- Number of states. */
#define YYNSTATES  199

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   299

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    47,     2,     2,
      51,    52,    45,    43,    54,    44,     2,    46,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    50,     2,    53,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    48,    49
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     4,     6,     9,    11,    14,    16,    19,
      21,    24,    27,    28,    30,    34,    39,    46,    52,    53,
      59,    60,    61,    70,    73,    77,    83,    87,    90,    93,
      96,    98,   102,   104,   107,   111,   114,   119,   124,   126,
     128,   130,   132,   135,   138,   140,   143,   148,   150,   153,
     154,   156,   158,   160,   162,   163,   165,   167,   169,   171,
     173,   174,   176,   178,   181,   185,   186,   188,   190,   192,
     195,   199,   203,   207,   211,   215,   219,   223,   227,   231,
     233,   235,   240,   244,   250,   254,   258,   262,   266,   270,
     273,   276,   277,   279,   281,   283,   285,   287,   292,   293,
     295,   297,   299,   301,   303,   305,   309,   310,   312,   313,
     315,   317,   320,   324,   327,   331,   333,   335,   337,   339,
     341,   343,   345,   349,   352
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      56,     0,    -1,    -1,    57,    -1,    57,    61,    -1,    59,
      -1,    57,    59,    -1,    59,    -1,    58,    59,    -1,     3,
      -1,    61,     3,    -1,     1,     3,    -1,    -1,     3,    -1,
       8,    58,     9,    -1,    66,    84,    60,    61,    -1,    66,
      84,    60,    61,    70,    61,    -1,    67,    86,    71,    72,
       9,    -1,    -1,    69,    62,    84,     3,    61,    -1,    -1,
      -1,    68,     3,    63,    61,     3,    12,    64,    84,    -1,
      23,    96,    -1,    29,    38,    86,    -1,     6,    80,    78,
      79,    83,    -1,     7,    79,    83,    -1,    24,    87,    -1,
      14,    77,    -1,    15,    77,    -1,    16,    -1,    16,    86,
      29,    -1,    22,    -1,    17,    87,    -1,    65,    58,     9,
      -1,    21,    87,    -1,    29,    51,    91,    52,    -1,    29,
       3,     8,     3,    -1,    10,    -1,    19,    -1,    13,    -1,
      12,    -1,    11,    60,    -1,    20,    60,    -1,    73,    -1,
      72,    73,    -1,    86,    52,    61,    74,    -1,     3,    -1,
      74,     3,    -1,    -1,    29,    -1,    29,    -1,    31,    -1,
      32,    -1,    -1,    30,    -1,     4,    -1,     5,    -1,    30,
      -1,    29,    -1,    -1,    81,    -1,    82,    -1,    81,    82,
      -1,    29,    38,    30,    -1,    -1,    93,    -1,    86,    -1,
      85,    -1,    48,    84,    -1,    51,    84,    52,    -1,    84,
      36,    84,    -1,    84,    35,    84,    -1,    84,    38,    84,
      -1,    84,    42,    84,    -1,    84,    40,    84,    -1,    84,
      37,    84,    -1,    84,    41,    84,    -1,    84,    39,    84,
      -1,    86,    -1,    88,    -1,    18,    76,    75,    75,    -1,
      51,    86,    52,    -1,    86,    50,    29,    89,    53,    -1,
      86,    43,    86,    -1,    86,    44,    86,    -1,    86,    45,
      86,    -1,    86,    46,    86,    -1,    86,    47,    86,    -1,
      44,    86,    -1,    43,    86,    -1,    -1,    86,    -1,    90,
      -1,    27,    -1,    28,    -1,    26,    -1,    29,    51,    91,
      52,    -1,    -1,    45,    -1,    30,    -1,    33,    -1,    31,
      -1,    32,    -1,    29,    -1,    51,    92,    52,    -1,    -1,
      96,    -1,    -1,    93,    -1,    94,    -1,    93,    94,    -1,
      93,    54,    94,    -1,    93,     1,    -1,    29,    95,    86,
      -1,    38,    -1,    42,    -1,    40,    -1,    37,    -1,    41,
      -1,    39,    -1,    97,    -1,    96,    54,    97,    -1,    96,
      97,    -1,    86,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   172,   172,   173,   174,   177,   181,   187,   193,   201,
     205,   216,   224,   225,   228,   233,   241,   249,   257,   257,
     266,   266,   266,   274,   279,   285,   293,   299,   304,   312,
     320,   329,   338,   344,   349,   356,   364,   379,   408,   414,
     420,   426,   432,   438,   441,   446,   453,   462,   463,   467,
     470,   473,   474,   475,   483,   486,   492,   496,   502,   506,
     515,   518,   521,   530,   539,   548,   551,   558,   561,   562,
     568,   572,   579,   586,   593,   600,   607,   614,   621,   630,
     633,   634,   652,   656,   672,   679,   686,   693,   700,   707,
     713,   720,   723,   726,   731,   736,   741,   745,   763,   766,
     772,   777,   782,   787,   792,   797,   805,   808,   812,   815,
     818,   823,   828,   833,   836,   849,   853,   857,   861,   865,
     869,   875,   880,   885,   892
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "EOL", "AUTH", "ACCT", "SEND", "EXPECT", 
  "T_BEGIN", "T_END", "IF", "ELSE", "WHILE", "DO", "BREAK", "CONTINUE", 
  "INPUT", "SHIFT", "GETOPT", "CASE", "IN", "T_RETURN", "SET", "PRINT", 
  "EXIT", "T_BOGUS", "ARGCOUNT", "IDENT", "PARM", "NAME", "NUMBER", 
  "QUOTE", "BSTRING", "IPADDRESS", "PRITEM", "OR", "AND", "NE", "EQ", 
  "GE", "GT", "LE", "LT", "'+'", "'-'", "'*'", "'/'", "'%'", "NOT", 
  "UMINUS", "'['", "'('", "')'", "']'", "','", "$accept", "program", 
  "input", "list", "lstmt", "maybe_eol", "stmt", "@1", "@2", "@3", 
  "function_def", "if", "case", "do", "while", "else", "in", "caselist", 
  "casecond", "nls", "name", "string", "nesting_level", "port_type", 
  "req_code", "send_flags", "send_flag_list", "send_flag", 
  "expr_or_pair_list", "cond", "bool", "expr", "maybe_expr", "value", 
  "closure", "imm_value", "maybe_prlist", "maybe_pair_list", "pair_list", 
  "pair", "op", "prlist", "pritem", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,    43,    45,    42,    47,    37,   298,   299,
      91,    40,    41,    93,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    55,    56,    56,    56,    57,    57,    58,    58,    59,
      59,    59,    60,    60,    61,    61,    61,    61,    62,    61,
      63,    64,    61,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    65,    66,    67,
      68,    69,    70,    71,    72,    72,    73,    74,    74,    75,
      75,    76,    76,    76,    77,    77,    78,    78,    79,    79,
      80,    80,    81,    81,    82,    83,    83,    83,    84,    84,
      84,    84,    84,    84,    84,    84,    84,    84,    84,    85,
      86,    86,    86,    86,    86,    86,    86,    86,    86,    86,
      86,    87,    87,    88,    88,    88,    88,    88,    89,    89,
      90,    90,    90,    90,    90,    90,    91,    91,    92,    92,
      93,    93,    93,    93,    94,    95,    95,    95,    95,    95,
      95,    96,    96,    96,    97
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     1,     2,     1,     2,     1,     2,     1,
       2,     2,     0,     1,     3,     4,     6,     5,     0,     5,
       0,     0,     8,     2,     3,     5,     3,     2,     2,     2,
       1,     3,     1,     2,     3,     2,     4,     4,     1,     1,
       1,     1,     2,     2,     1,     2,     4,     1,     2,     0,
       1,     1,     1,     1,     0,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     3,     0,     1,     1,     1,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     4,     3,     5,     3,     3,     3,     3,     3,     2,
       2,     0,     1,     1,     1,     1,     1,     4,     0,     1,
       1,     1,     1,     1,     1,     3,     0,     1,     0,     1,
       1,     2,     3,     2,     3,     1,     1,     1,     1,     1,
       1,     1,     3,     2,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     0,     9,    60,     0,     0,    38,    41,    40,    54,
      54,    30,    91,    39,    91,    32,     0,    91,     0,     0,
       0,     5,     0,     0,     0,     0,     0,    18,    11,     0,
       0,    61,    62,    59,    58,    65,     0,     7,    55,    28,
      29,     0,    96,    94,    95,   104,   100,   102,   103,   101,
       0,     0,   108,     0,    80,    93,    92,    33,    35,   124,
      23,   121,    27,     0,     0,   106,     1,     6,     4,    10,
       0,     0,   108,    12,    68,    79,     0,    20,     0,     0,
      56,    57,     0,    63,   104,    26,    67,     0,   110,    14,
       8,    51,    52,    53,    49,   106,    90,    89,     0,     0,
       0,    31,     0,     0,     0,     0,     0,     0,     0,   123,
       0,    24,     0,   107,    34,    69,     0,    79,    13,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    12,     0,
       0,     0,    64,    65,   118,   115,   120,   117,   119,   116,
       0,   113,     0,     0,   111,    50,    49,     0,    82,   105,
      84,    85,    86,    87,    88,    98,   122,    37,    36,    70,
      72,    71,    76,    73,    78,    75,    77,    74,    15,    43,
       0,    44,     0,     0,     0,    25,   114,   112,    81,    97,
      99,     0,    12,     0,    17,    45,     0,     0,    19,    83,
      42,    16,     0,    21,    47,    46,     0,    48,    22
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    19,    20,    36,    37,   127,    22,    78,   130,   196,
      23,    24,    25,    26,    27,   183,   129,   170,   171,   195,
     146,    94,    39,    82,    35,    30,    31,    32,    85,    73,
      74,    75,    57,    54,   181,    55,   112,    99,    87,    88,
     140,   113,    61
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -126
static const short yypact[] =
{
     326,    21,  -126,    -3,   -16,   423,  -126,  -126,  -126,    13,
      13,   253,   253,  -126,   253,  -126,   253,   253,    48,    39,
     351,  -126,    50,   423,   199,   253,    53,  -126,  -126,    14,
      25,    -3,  -126,  -126,  -126,   280,   375,  -126,  -126,  -126,
    -126,    16,  -126,  -126,  -126,     7,  -126,  -126,  -126,  -126,
     253,   253,   280,   161,  -126,  -126,   244,  -126,  -126,   244,
     170,  -126,  -126,    51,   253,   253,  -126,  -126,    50,  -126,
     399,   199,   226,   137,  -126,   244,   190,  -126,   199,    30,
    -126,  -126,   -16,  -126,    -5,  -126,   244,     9,  -126,  -126,
    -126,  -126,  -126,  -126,    44,   253,    26,    26,   439,    27,
      20,  -126,   253,   253,   253,   253,   253,    52,   253,  -126,
      74,   244,    45,   170,  -126,  -126,   438,   439,  -126,   199,
     199,   199,   199,   199,   199,   199,   199,   443,    97,   253,
     443,   145,  -126,   280,  -126,  -126,  -126,  -126,  -126,  -126,
     253,  -126,   105,    72,  -126,  -126,    44,    54,  -126,  -126,
      37,    37,    26,    26,    26,    57,  -126,  -126,  -126,  -126,
     278,   465,   471,   471,    49,    49,    49,    49,    93,  -126,
     106,  -126,   449,   102,   443,  -126,   244,  -126,  -126,  -126,
    -126,    55,    97,   443,  -126,  -126,   443,    99,  -126,  -126,
    -126,  -126,   109,  -126,  -126,   110,   199,  -126,   225
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
    -126,  -126,  -126,    86,     8,  -125,   -20,  -126,  -126,  -126,
    -126,  -126,  -126,  -126,  -126,  -126,  -126,  -126,   -56,  -126,
     -30,  -126,   107,  -126,    36,  -126,  -126,    89,   -12,   -55,
    -126,   -10,     5,  -126,  -126,  -126,    31,  -126,   -41,   -82,
    -126,   111,   -33
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -110
static const short yytable[] =
{
      68,    53,    56,   169,    56,   144,    59,    56,    21,   -66,
     141,   100,   -66,    33,    34,    76,   115,   116,   144,    58,
     -66,   141,    62,   131,    28,    86,    29,   109,    67,    80,
      81,   100,   134,   135,   136,   137,   138,   139,   142,    66,
      96,    97,    98,    38,    90,    91,    95,    92,    93,   142,
      59,    63,    79,    69,   111,    59,    77,   190,    95,   110,
     132,   177,   117,   143,   160,   161,   162,   163,   164,   165,
     166,   167,  -109,   145,   143,   156,   107,   157,    90,   149,
     109,   155,   104,   105,   106,    59,    64,   107,  -110,  -110,
    -110,  -110,   150,   151,   152,   153,   154,   158,    59,    65,
     118,   142,   180,    59,   182,   187,   179,   168,   189,    70,
     173,   193,   194,   197,   185,   184,   178,    40,   133,   172,
      83,   175,     0,    86,    41,     0,   147,    60,     0,     0,
     176,     0,    42,    43,    44,    45,    46,    47,    48,    49,
     118,   198,   134,   135,   136,   137,   138,   139,   174,    50,
      51,     0,     0,     0,   188,     0,     0,    52,     0,     0,
     172,     0,     0,   191,     0,     0,   192,     0,     0,     0,
       0,     0,   119,   120,   121,   122,   123,   124,   125,   126,
     119,   120,   121,   122,   123,   124,   125,   126,    41,     0,
     101,     0,     0,     0,     0,     0,    42,    43,    44,    45,
      46,    47,    48,    49,   102,   103,   104,   105,   106,     0,
     128,   107,     0,    50,    51,     0,     0,    41,     0,     0,
       0,    52,     0,     0,   108,    42,    43,    44,    45,    46,
      47,    48,    49,   102,   103,   104,   105,   106,     0,     0,
     107,     0,    50,    51,    41,     0,     0,    71,     0,     0,
      72,     0,    42,    43,    44,    84,    46,    47,    48,    49,
     119,   120,   121,   122,   123,   124,   125,   126,     0,    50,
      51,    41,     0,     0,    71,     0,     0,    72,     0,    42,
      43,    44,    45,    46,    47,    48,    49,   102,   103,   104,
     105,   106,     0,     0,   107,     0,    50,    51,    41,     0,
       0,     0,     0,     0,    52,     0,    42,    43,    44,    84,
      46,    47,    48,    49,   120,   121,   122,   123,   124,   125,
     126,     0,     0,    50,    51,     0,    -2,     1,     0,     2,
       0,    52,     3,     4,     5,     0,     6,     0,     7,     8,
       9,    10,    11,    12,     0,    13,     0,    14,    15,    16,
      17,    -3,     1,     0,     2,    18,     0,     3,     4,     5,
       0,     6,     0,     7,     8,     9,    10,    11,    12,     0,
      13,     0,    14,    15,    16,    17,     1,     0,     2,     0,
      18,     3,     4,     5,    89,     6,     0,     7,     8,     9,
      10,    11,    12,     0,    13,     0,    14,    15,    16,    17,
       1,     0,     2,     0,    18,     3,     4,     5,   114,     6,
       0,     7,     8,     9,    10,    11,    12,     0,    13,     0,
      14,    15,    16,    17,     1,     0,     2,     0,    18,     3,
       4,     5,     0,     6,     0,     7,     8,     9,    10,    11,
      12,     0,    13,     0,    14,    15,    16,    17,     0,     3,
       4,     5,    18,     6,     0,     7,     8,     9,    10,    11,
      12,     0,    13,     0,    14,    15,    16,    17,     0,     0,
       0,     0,    18,   119,   120,   121,   122,   123,   124,   125,
     126,     0,   102,   103,   104,   105,   106,     0,     0,   107,
     159,   148,   102,   103,   104,   105,   106,     0,     0,   107,
       0,   186,   121,   122,   123,   124,   125,   126,  -110,  -110,
     123,   124,   125,   126
};

static const short yycheck[] =
{
      20,    11,    12,   128,    14,    87,    16,    17,     0,     0,
       1,    52,     3,    29,    30,    25,    71,    72,   100,    14,
      11,     1,    17,    78,     3,    35,    29,    60,    20,     4,
       5,    72,    37,    38,    39,    40,    41,    42,    29,     0,
      50,    51,    52,    30,    36,    29,    51,    31,    32,    29,
      60,     3,    38,     3,    64,    65,     3,   182,    51,     8,
      30,   143,    72,    54,   119,   120,   121,   122,   123,   124,
     125,   126,    52,    29,    54,   108,    50,     3,    70,    52,
     113,    29,    45,    46,    47,    95,    38,    50,    39,    40,
      41,    42,   102,   103,   104,   105,   106,    52,   108,    51,
       3,    29,    45,   113,    11,     3,    52,   127,    53,    23,
     130,    12,     3,     3,   170,     9,   146,    10,    82,   129,
      31,   133,    -1,   133,    18,    -1,    95,    16,    -1,    -1,
     140,    -1,    26,    27,    28,    29,    30,    31,    32,    33,
       3,   196,    37,    38,    39,    40,    41,    42,     3,    43,
      44,    -1,    -1,    -1,   174,    -1,    -1,    51,    -1,    -1,
     170,    -1,    -1,   183,    -1,    -1,   186,    -1,    -1,    -1,
      -1,    -1,    35,    36,    37,    38,    39,    40,    41,    42,
      35,    36,    37,    38,    39,    40,    41,    42,    18,    -1,
      29,    -1,    -1,    -1,    -1,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    43,    44,    45,    46,    47,    -1,
      20,    50,    -1,    43,    44,    -1,    -1,    18,    -1,    -1,
      -1,    51,    -1,    -1,    54,    26,    27,    28,    29,    30,
      31,    32,    33,    43,    44,    45,    46,    47,    -1,    -1,
      50,    -1,    43,    44,    18,    -1,    -1,    48,    -1,    -1,
      51,    -1,    26,    27,    28,    29,    30,    31,    32,    33,
      35,    36,    37,    38,    39,    40,    41,    42,    -1,    43,
      44,    18,    -1,    -1,    48,    -1,    -1,    51,    -1,    26,
      27,    28,    29,    30,    31,    32,    33,    43,    44,    45,
      46,    47,    -1,    -1,    50,    -1,    43,    44,    18,    -1,
      -1,    -1,    -1,    -1,    51,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    36,    37,    38,    39,    40,    41,
      42,    -1,    -1,    43,    44,    -1,     0,     1,    -1,     3,
      -1,    51,     6,     7,     8,    -1,    10,    -1,    12,    13,
      14,    15,    16,    17,    -1,    19,    -1,    21,    22,    23,
      24,     0,     1,    -1,     3,    29,    -1,     6,     7,     8,
      -1,    10,    -1,    12,    13,    14,    15,    16,    17,    -1,
      19,    -1,    21,    22,    23,    24,     1,    -1,     3,    -1,
      29,     6,     7,     8,     9,    10,    -1,    12,    13,    14,
      15,    16,    17,    -1,    19,    -1,    21,    22,    23,    24,
       1,    -1,     3,    -1,    29,     6,     7,     8,     9,    10,
      -1,    12,    13,    14,    15,    16,    17,    -1,    19,    -1,
      21,    22,    23,    24,     1,    -1,     3,    -1,    29,     6,
       7,     8,    -1,    10,    -1,    12,    13,    14,    15,    16,
      17,    -1,    19,    -1,    21,    22,    23,    24,    -1,     6,
       7,     8,    29,    10,    -1,    12,    13,    14,    15,    16,
      17,    -1,    19,    -1,    21,    22,    23,    24,    -1,    -1,
      -1,    -1,    29,    35,    36,    37,    38,    39,    40,    41,
      42,    -1,    43,    44,    45,    46,    47,    -1,    -1,    50,
      52,    52,    43,    44,    45,    46,    47,    -1,    -1,    50,
      -1,    52,    37,    38,    39,    40,    41,    42,    37,    38,
      39,    40,    41,    42
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     6,     7,     8,    10,    12,    13,    14,
      15,    16,    17,    19,    21,    22,    23,    24,    29,    56,
      57,    59,    61,    65,    66,    67,    68,    69,     3,    29,
      80,    81,    82,    29,    30,    79,    58,    59,    30,    77,
      77,    18,    26,    27,    28,    29,    30,    31,    32,    33,
      43,    44,    51,    86,    88,    90,    86,    87,    87,    86,
      96,    97,    87,     3,    38,    51,     0,    59,    61,     3,
      58,    48,    51,    84,    85,    86,    86,     3,    62,    38,
       4,     5,    78,    82,    29,    83,    86,    93,    94,     9,
      59,    29,    31,    32,    76,    51,    86,    86,    86,    92,
      93,    29,    43,    44,    45,    46,    47,    50,    54,    97,
       8,    86,    91,    96,     9,    84,    84,    86,     3,    35,
      36,    37,    38,    39,    40,    41,    42,    60,    20,    71,
      63,    84,    30,    79,    37,    38,    39,    40,    41,    42,
      95,     1,    29,    54,    94,    29,    75,    91,    52,    52,
      86,    86,    86,    86,    86,    29,    97,     3,    52,    52,
      84,    84,    84,    84,    84,    84,    84,    84,    61,    60,
      72,    73,    86,    61,     3,    83,    86,    94,    75,    52,
      45,    89,    11,    70,     9,    73,    52,     3,    61,    53,
      60,    61,    61,    12,     3,    74,    64,     3,    84
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 5:
#line 178 "gram.y"
    {
			run_statement(yyvsp[0].node);
		}
    break;

  case 6:
#line 182 "gram.y"
    {
			run_statement(yyvsp[0].node);
		}
    break;

  case 7:
#line 188 "gram.y"
    {
			yyval.list = grad_list_create();
			if (yyvsp[0].node)
				grad_list_append(yyval.list, yyvsp[0].node);
		}
    break;

  case 8:
#line 194 "gram.y"
    {
			if (yyvsp[0].node) 
				grad_list_append(yyvsp[-1].list, yyvsp[0].node);
			yyval.list = yyvsp[-1].list;
		}
    break;

  case 9:
#line 202 "gram.y"
    {
			yyval.node = NULL;
		}
    break;

  case 10:
#line 206 "gram.y"
    {
			switch (peek_ctx()) {
			case ctx_iferr:
			case ctx_doerr:
				pop_ctx();
				break;
			default:
				break;
			}
		}
    break;

  case 11:
#line 217 "gram.y"
    {
			errsync();
                        yyclearin;
                        yyerrok;
                }
    break;

  case 14:
#line 229 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_stmt);
			yyval.node->v.list = yyvsp[-1].list;			
		}
    break;

  case 15:
#line 234 "gram.y"
    {
			pop_ctx();
			yyval.node = radtest_node_alloc(radtest_node_cond);
			yyval.node->v.cond.cond = yyvsp[-2].node;
			yyval.node->v.cond.iftrue = yyvsp[0].node;
			yyval.node->v.cond.iffalse = NULL;
		}
    break;

  case 16:
#line 242 "gram.y"
    {
			pop_ctx();
			yyval.node = radtest_node_alloc(radtest_node_cond);
			yyval.node->v.cond.cond = yyvsp[-4].node;
			yyval.node->v.cond.iftrue = yyvsp[-2].node;
			yyval.node->v.cond.iffalse = yyvsp[0].node;
		}
    break;

  case 17:
#line 250 "gram.y"
    {
			pop_ctx();
			yyval.node = radtest_node_alloc(radtest_node_case);
			yyval.node->locus = yyvsp[-3].node->locus;
			yyval.node->v.branch.expr = yyvsp[-3].node;
			yyval.node->v.branch.branchlist = yyvsp[-1].list;
		}
    break;

  case 18:
#line 257 "gram.y"
    { current_nesting_level++; }
    break;

  case 19:
#line 258 "gram.y"
    {
			pop_ctx();
			current_nesting_level--;
			yyval.node = radtest_node_alloc(radtest_node_loop);
			yyval.node->v.loop.cond = yyvsp[-2].node;
			yyval.node->v.loop.body = yyvsp[0].node;
			yyval.node->v.loop.first_pass = 0;
		}
    break;

  case 20:
#line 266 "gram.y"
    { current_nesting_level++; }
    break;

  case 21:
#line 266 "gram.y"
    { current_nesting_level--; }
    break;

  case 22:
#line 267 "gram.y"
    {
			pop_ctx();
			yyval.node = radtest_node_alloc(radtest_node_loop);
			yyval.node->v.loop.cond = yyvsp[0].node;
			yyval.node->v.loop.body = yyvsp[-4].node;
			yyval.node->v.loop.first_pass = 1;
		}
    break;

  case 23:
#line 275 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_print);
			yyval.node->v.list = yyvsp[0].list;
		}
    break;

  case 24:
#line 280 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_asgn);
			yyval.node->v.asgn.name = yyvsp[-2].string;
			yyval.node->v.asgn.expr = yyvsp[0].node;
		}
    break;

  case 25:
#line 286 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_send);
			yyval.node->v.send.cntl = yyvsp[-3].symtab;
			yyval.node->v.send.port_type = yyvsp[-2].i;
			yyval.node->v.send.code = yyvsp[-1].i;
			yyval.node->v.send.expr = yyvsp[0].node;
		}
    break;

  case 26:
#line 294 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_expect);
			yyval.node->v.expect.code = yyvsp[-1].i;
			yyval.node->v.expect.expr = yyvsp[0].node;
		}
    break;

  case 27:
#line 300 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_exit);
			yyval.node->v.expr = yyvsp[0].node;
		}
    break;

  case 28:
#line 305 "gram.y"
    {
			if (yyvsp[0].i > current_nesting_level) {
				parse_error(_("not enough 'while's to break from"));
			}
			yyval.node = radtest_node_alloc(radtest_node_break);
			yyval.node->v.level = yyvsp[0].i;
		}
    break;

  case 29:
#line 313 "gram.y"
    {
			if (yyvsp[0].i > current_nesting_level) {
				parse_error(_("not enough 'while's to continue"));
			}
			yyval.node = radtest_node_alloc(radtest_node_continue);
			yyval.node->v.level = yyvsp[0].i;
		}
    break;

  case 30:
#line 321 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_input);
			yyval.node->v.input.expr = NULL;
			yyval.node->v.input.var = (radtest_variable_t*)
				grad_sym_lookup_or_install(vartab,
							   "INPUT",
							   1);
		}
    break;

  case 31:
#line 330 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_input);
			yyval.node->v.input.expr = yyvsp[-1].node;
			yyval.node->v.input.var = (radtest_variable_t*)
				grad_sym_lookup_or_install(vartab,
							   yyvsp[0].string,
							   1);
		}
    break;

  case 32:
#line 339 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_set);
			yyval.node->v.set.argc = yyvsp[0].set.argc;
			yyval.node->v.set.argv = yyvsp[0].set.argv;
		}
    break;

  case 33:
#line 345 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_shift);
			yyval.node->v.expr = yyvsp[0].node;
		}
    break;

  case 34:
#line 350 "gram.y"
    {
			yyvsp[-2].fun->body = yyvsp[-1].list;
			radtest_fix_mem();
			yyval.node = NULL;
			defn.function = NULL;
		}
    break;

  case 35:
#line 357 "gram.y"
    {
			if (!defn.function) {
				parse_error(_("return outside of a function definition"));
			}
			yyval.node = radtest_node_alloc(radtest_node_return);
			yyval.node->v.expr = yyvsp[0].node;
		}
    break;

  case 36:
#line 365 "gram.y"
    {
			radtest_function_t *fun;
			
			fun = (radtest_function_t*)
				grad_sym_lookup(functab, yyvsp[-3].string);
			if (!fun) {
				parse_error(_("undefined function `%s'"), yyvsp[-3].string);
			}
			yyval.node = radtest_node_alloc(radtest_node_call);
			yyval.node->v.call.fun = fun;
			yyval.node->v.call.args = yyvsp[-1].list;
		}
    break;

  case 37:
#line 380 "gram.y"
    {
			radtest_function_t *fun;
			
			if (defn.function) {
				parse_error(_("nested function definitions "
					      "are not allowed"));
				parse_error_loc(&defn.locus,
						_("the current function "
						  "definition begins here"));
				YYERROR; /* FIXME */
			}
			defn.function = yyvsp[-3].string;
			defn.locus = source_locus;
			fun = (radtest_function_t*)
				grad_sym_lookup_or_install(functab, yyvsp[-3].string, 1);
			if (fun->body) {
				parse_error(_("redefinition of function `%s'"), yyvsp[-3].string);
				parse_error_loc(&fun->locus,
					     _("`%s' previously defined here"),
						yyvsp[-3].string);

				YYERROR; /* FIXME */
			}
			fun->locus = source_locus;
			yyval.fun = fun;
		}
    break;

  case 38:
#line 409 "gram.y"
    {
			push_ctx(ctx_if);
		}
    break;

  case 39:
#line 415 "gram.y"
    {
			push_ctx(ctx_case);
		}
    break;

  case 40:
#line 421 "gram.y"
    {
			push_ctx(ctx_do);
		}
    break;

  case 41:
#line 427 "gram.y"
    {
			push_ctx(ctx_while);
		}
    break;

  case 42:
#line 433 "gram.y"
    {
			pop_ctx();
		}
    break;

  case 44:
#line 442 "gram.y"
    {
			yyval.list = grad_list_create();
			grad_list_append(yyval.list, yyvsp[0].case_branch);
		}
    break;

  case 45:
#line 447 "gram.y"
    {
			grad_list_append(yyvsp[-1].list, yyvsp[0].case_branch);
			yyval.list = yyvsp[-1].list;
		}
    break;

  case 46:
#line 454 "gram.y"
    {
			radtest_case_branch_t *p = radtest_branch_alloc();
			p->cond = yyvsp[-3].node;
			p->node = yyvsp[-1].node;
			yyval.case_branch = p;
		}
    break;

  case 49:
#line 467 "gram.y"
    {
			yyval.string = NULL;
		}
    break;

  case 53:
#line 476 "gram.y"
    {
			parse_error(_("warning: truncating binary string"));
			yyval.string = yyvsp[0].bstring.ptr;
		}
    break;

  case 54:
#line 483 "gram.y"
    {
			yyval.i = 1;
		}
    break;

  case 55:
#line 487 "gram.y"
    {
			yyval.i = yyvsp[0].number;
		}
    break;

  case 56:
#line 493 "gram.y"
    {
			yyval.i = GRAD_PORT_AUTH;
		}
    break;

  case 57:
#line 497 "gram.y"
    {
			yyval.i = GRAD_PORT_ACCT;
		}
    break;

  case 58:
#line 503 "gram.y"
    {
			yyval.i = yyvsp[0].number;
		}
    break;

  case 59:
#line 507 "gram.y"
    {
			yyval.i = grad_request_name_to_code(yyvsp[0].string);
			if (yyval.i == 0) 
				parse_error(_("expected integer value or request code name"));
		}
    break;

  case 60:
#line 515 "gram.y"
    {
			yyval.symtab = NULL;
		}
    break;

  case 62:
#line 522 "gram.y"
    {
			radtest_variable_t *var;
			
			yyval.symtab = grad_symtab_create(sizeof(*var), var_free);
			var = (radtest_variable_t*) grad_sym_install(yyval.symtab,
								     yyvsp[0].var->name);
			radtest_var_copy (var, yyvsp[0].var);
		}
    break;

  case 63:
#line 531 "gram.y"
    {
			radtest_variable_t *var;
			var = (radtest_variable_t*) grad_sym_install(yyvsp[-1].symtab,
								     yyvsp[0].var->name);
			radtest_var_copy (var, yyvsp[0].var); /* FIXME: check this */
		}
    break;

  case 64:
#line 540 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_integer);
			yyval.var->name = yyvsp[-2].string;
			yyval.var->datum.number = yyvsp[0].number;
		}
    break;

  case 65:
#line 548 "gram.y"
    {
			yyval.node = NULL;
		}
    break;

  case 66:
#line 552 "gram.y"
    {
			radtest_variable_t *var = radtest_var_alloc(rtv_pairlist);
			var->datum.list = yyvsp[0].list;
			yyval.node = radtest_node_alloc(radtest_node_value);
			yyval.node->v.var = var;
		}
    break;

  case 69:
#line 563 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_unary);
			yyval.node->v.unary.op = radtest_op_not;
			yyval.node->v.unary.operand = yyvsp[0].node;
		}
    break;

  case 70:
#line 569 "gram.y"
    {
			yyval.node = yyvsp[-1].node;
		}
    break;

  case 71:
#line 573 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_and;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 72:
#line 580 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_or;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 73:
#line 587 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_eq;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 74:
#line 594 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_lt;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 75:
#line 601 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_gt;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 76:
#line 608 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_ne;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 77:
#line 615 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_le;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 78:
#line 622 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_ge;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 81:
#line 635 "gram.y"
    {
			char *name = yyvsp[-1].string ? yyvsp[-1].string : "OPTVAR";
			yyval.node = radtest_node_alloc(radtest_node_getopt);
			yyval.node->v.gopt.last = 0;
			yyval.node->v.gopt.optstr = yyvsp[-2].string;
			yyval.node->v.gopt.var = (radtest_variable_t*)
				grad_sym_lookup_or_install(vartab, name, 1);

			name = yyvsp[0].string ? yyvsp[0].string : "OPTARG";
			yyval.node->v.gopt.arg = (radtest_variable_t*)
				grad_sym_lookup_or_install(vartab, name, 1);

			name = yyvsp[0].string ? yyvsp[0].string : "OPTIND";
			yyval.node->v.gopt.ind = (radtest_variable_t*)
				grad_sym_lookup_or_install(vartab, name, 1);
			
		}
    break;

  case 82:
#line 653 "gram.y"
    {
			yyval.node = yyvsp[-1].node;
		}
    break;

  case 83:
#line 657 "gram.y"
    {
			grad_dict_attr_t *dict = grad_attr_name_to_dict(yyvsp[-2].string);
			if (!dict) {
				parse_error(_("unknown attribute `%s'"), yyvsp[-2].string);
				yyval.node = NULL;
			} else {
				yyval.node = radtest_node_alloc(radtest_node_attr);
				yyval.node->v.attr.node = yyvsp[-4].node;
				yyval.node->v.attr.dict = dict;
				yyval.node->v.attr.all = yyvsp[-1].i;
				if (yyvsp[-1].i && dict->type != GRAD_TYPE_STRING) 
					parse_error(
		     _("warning: '*' is meaningless for this attribute type"));
			}
		}
    break;

  case 84:
#line 673 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_add;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 85:
#line 680 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_sub;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 86:
#line 687 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_mul;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 87:
#line 694 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_div;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 88:
#line 701 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_bin);
			yyval.node->v.bin.op = radtest_op_mod;
			yyval.node->v.bin.left = yyvsp[-2].node;
			yyval.node->v.bin.right = yyvsp[0].node;
		}
    break;

  case 89:
#line 708 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_unary);
			yyval.node->v.unary.op = radtest_op_neg;
			yyval.node->v.unary.operand = yyvsp[0].node;
		}
    break;

  case 90:
#line 714 "gram.y"
    {
			yyval.node = yyvsp[0].node;
		}
    break;

  case 91:
#line 720 "gram.y"
    {
			yyval.node = NULL;
		}
    break;

  case 93:
#line 727 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_value);
			yyval.node->v.var = yyvsp[0].var;
		}
    break;

  case 94:
#line 732 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_deref);
			yyval.node->v.deref = yyvsp[0].deref;
		}
    break;

  case 95:
#line 737 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_parm);
			yyval.node->v.parm = yyvsp[0].parm;
		}
    break;

  case 96:
#line 742 "gram.y"
    {
			yyval.node = radtest_node_alloc(radtest_node_argcount);
		}
    break;

  case 97:
#line 746 "gram.y"
    {
			radtest_function_t *fun;
			
			fun = (radtest_function_t*)
				grad_sym_lookup(functab, yyvsp[-3].string);
			if (!fun) {
				parse_error(_("undefined function `%s'"), yyvsp[-3].string);
				yyval.node = NULL;
			} else {
				yyval.node = radtest_node_alloc(radtest_node_call);
				yyval.node->v.call.fun = fun;
				yyval.node->v.call.args = yyvsp[-1].list;
			}
		}
    break;

  case 98:
#line 763 "gram.y"
    {
			yyval.i = 0;
		}
    break;

  case 99:
#line 767 "gram.y"
    {
			yyval.i = 1;
		}
    break;

  case 100:
#line 773 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_integer);
			yyval.var->datum.number = yyvsp[0].number;
		}
    break;

  case 101:
#line 778 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_ipaddress);
			yyval.var->datum.ipaddr = yyvsp[0].ipaddr;
		}
    break;

  case 102:
#line 783 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_string);
			yyval.var->datum.string = yyvsp[0].string;
		}
    break;

  case 103:
#line 788 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_bstring);
			yyval.var->datum.bstring = yyvsp[0].bstring;
		}
    break;

  case 104:
#line 793 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_string);
			yyval.var->datum.string = yyvsp[0].string;
		}
    break;

  case 105:
#line 798 "gram.y"
    {
			yyval.var = radtest_var_alloc(rtv_pairlist);
			yyval.var->datum.list = yyvsp[-1].list;
		}
    break;

  case 106:
#line 805 "gram.y"
    {
			yyval.list = NULL;
		}
    break;

  case 108:
#line 812 "gram.y"
    {
			yyval.list = NULL;
		}
    break;

  case 110:
#line 819 "gram.y"
    {
			yyval.list = grad_list_create();
			grad_list_append(yyval.list, yyvsp[0].pair);
		}
    break;

  case 111:
#line 824 "gram.y"
    {
			grad_list_append(yyvsp[-1].list, yyvsp[0].pair);
			yyval.list = yyvsp[-1].list;
		}
    break;

  case 112:
#line 829 "gram.y"
    {
			grad_list_append(yyvsp[-2].list, yyvsp[0].pair);
			yyval.list = yyvsp[-2].list;
		}
    break;

  case 114:
#line 837 "gram.y"
    {
			grad_dict_attr_t *attr = grad_attr_name_to_dict(yyvsp[-2].string);
			if (!attr) 
				parse_error(_("unknown attribute `%s'"), yyvsp[-2].string);

			yyval.pair = radtest_pair_alloc();
			yyval.pair->attr = attr;
			yyval.pair->op = yyvsp[-1].op;
			yyval.pair->node = yyvsp[0].node;
		}
    break;

  case 115:
#line 850 "gram.y"
    {
                        yyval.op = grad_operator_equal;
                }
    break;

  case 116:
#line 854 "gram.y"
    {
                        yyval.op = grad_operator_less_than;
                }
    break;

  case 117:
#line 858 "gram.y"
    { 
                        yyval.op = grad_operator_greater_than;
                }
    break;

  case 118:
#line 862 "gram.y"
    {
                        yyval.op = grad_operator_not_equal;
                }
    break;

  case 119:
#line 866 "gram.y"
    {
                        yyval.op = grad_operator_less_equal;
                }
    break;

  case 120:
#line 870 "gram.y"
    {
                        yyval.op = grad_operator_greater_equal;
                }
    break;

  case 121:
#line 876 "gram.y"
    {
			yyval.list = grad_list_create();
			grad_list_append(yyval.list, yyvsp[0].node);
		}
    break;

  case 122:
#line 881 "gram.y"
    {
			grad_list_append(yyvsp[-2].list, yyvsp[0].node);
			yyval.list = yyvsp[-2].list;
		}
    break;

  case 123:
#line 886 "gram.y"
    {
			grad_list_append(yyvsp[-1].list, yyvsp[0].node);
			yyval.list = yyvsp[-1].list;
		}
    break;


    }

/* Line 991 of yacc.c.  */
#line 2373 "gram.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:

  /* Suppress GCC warning that yyerrlab1 is unused when no action
     invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
  __attribute__ ((__unused__))
#endif


  goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
`---------------------------------------------------------------*/
yyerrlab2:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 895 "gram.y"


int
yyerror(char *s)
{
	if (strcmp(s, "parse error") == 0
	    || strcmp(s, "syntax error") == 0) {
		if (yychar == T_END)
			parse_error(_("Misplaced `end'"));
		else if (yychar == EOL) {
			grad_locus_t loc = source_locus;
			loc.line--;
			parse_error_loc(&loc, _("Unexpected end of line"));
		} else if (peek_ctx() == ctx_doerr)
			;
		else 
			parse_error(s);
	} else if (yychar == EOL) {
		grad_locus_t loc = source_locus;
		loc.line--;
		parse_error_loc(&loc, s);
	} else
		parse_error(s);
}

static char *funcname_displayed = NULL;

static int
namecmp(char *a, char *b)
{
	if (!a || !b)
		return a != b;
	return strcmp(a, b);
}

static void
print_function_name()
{
	if (namecmp(funcname_displayed, defn.function)) {
		if (defn.function)
			fprintf(stderr, _("In function `%s':\n"),
				defn.function);
		else
			fprintf(stderr, _("At top level:\n"));
		funcname_displayed = defn.function;
	}
}	

void
parse_error(const char *fmt, ...)
{
        va_list ap;

	print_function_name();
	va_start(ap, fmt);
        fprintf(stderr, "%s:%lu: ",
		source_locus.file,
		(unsigned long) source_locus.line);
        vfprintf(stderr, fmt, ap);
        va_end(ap);
        fprintf(stderr, "\n");
	error_count++;
}

void
parse_error_loc(grad_locus_t *locus, const char *fmt, ...)
{
        va_list ap;

	print_function_name();
	va_start(ap, fmt);
        fprintf(stderr, "%s:%lu: ",
		locus->file, (unsigned long) locus->line);
        vfprintf(stderr, fmt, ap);
        va_end(ap);
        fprintf(stderr, "\n");
	error_count++;
}

void
set_yydebug()
{
        extern int yydebug;
        if (debug_on(1)) {
                yydebug = 1;
        }
}

static void
run_statement(radtest_node_t *node)
{
	if (!dry_run) {
		if (!error_count)
			radtest_eval(node, toplevel_env);
		/* Clear error_count only if we are in interactive
		   mode. There is no use continuing executing of a script
		   after an erroneous statement. */
		if (interactive)
			error_count = 0;
	}
	radtest_free_mem();
}

int
read_and_eval(char *filename)
{
        if (open_input(filename))
                return 1;
        return (yyparse() || error_count) ? 1 : 0;
}

static void
errsync()
{
	enum context ctx = pop_ctx();
	switch (ctx) {
	case ctx_none:
		break;
		
	case ctx_if:
		push_ctx(ctx_iferr);
		break;
		
	case ctx_do:
		current_nesting_level--;
		push_ctx(ctx_doerr);
		break;

	case ctx_while:
		current_nesting_level--;
		break;
		
	case ctx_case:
		;
	}
}

